extends Node2D

const ANGULAR_SPEED = 2*PI/10.0 # rads/s

var inner_length:float = 110
var outer_length:float = 100

var inner_angle:float = 0 : set = set_inner_angle
var outer_angle:float = 0 : set = set_outer_angle

var target:Vector2 = Vector2.ZERO


func _ready():
	$InnerArm/Polygon2D.scale.x = inner_length/100
	$InnerArm/OuterArm/Polygon2D.scale.x = outer_length/100
	$InnerArm/OuterArm.position.x = inner_length
	
	

func set_inner_angle(value:float):
	inner_angle = value
	$InnerArm.rotation = inner_angle
	
	
func set_outer_angle(value:float):
	outer_angle = value
	$InnerArm/OuterArm.rotation = outer_angle
	
	
func _physics_process(delta):
	var rel_pos = target - position
	
	var x = rel_pos.length()
	var a = -acos((x/2 + (inner_length**2 - outer_length**2)/(2*x))/inner_length)
	var b = acos((x/2 - (inner_length**2 - outer_length**2)/(2*x))/outer_length)-a
	
	if x > inner_length + outer_length:
		a = 0
		b = 0
		
	inner_angle = a#lerpf(inner_angle, a, 0.5)
	outer_angle = b#lerpf(outer_angle, b, 0.5)
	
	rotation = rel_pos.angle()

	
