extends KinematicBody2D

signal col_detected(pos)

func _physics_process(_d):
	
	global_position = get_global_mouse_position()
	
	var col_pos = get_collision_pos()
#	var col_pos = get_collision_pos_direct_space_state()
	
	if col_pos != Vector2.INF:
		modulate = Color.red
		emit_signal("col_detected", col_pos)
	else:
		modulate = Color.white
		emit_signal("col_detected", null)
	
	
func get_collision_pos()->Vector2:
	var col = move_and_collide(Vector2.ZERO, true, true, true)
		
	if col != null:
		return col.position
	else:
		return Vector2.INF

func get_collision_pos_direct_space_state()->Vector2:
	var params = Physics2DShapeQueryParameters.new()
	params.set_shape($CollisionShape2D.shape)
	params.exclude = [self]
	params.collision_layer = collision_layer
	params.transform = global_transform
	
	var col = get_world_2d().direct_space_state.get_rest_info(params)
	if not col.empty():
		return col["point"]
	else:
		return Vector2.INF
