extends KinematicBody2D

const GRAVITY = 4000
const BELT_SPEED = 40

var velocity := Vector2.ZERO
var is_on_belt := false

func _physics_process(delta):
	
	is_on_belt = false
	var left_below = $LeftRayCast2D.get_collider()
	if left_below != null:
		if left_below.is_in_group("belts"):
			is_on_belt = true
		if left_below.is_in_group("boxes"):
			if left_below.is_on_belt:
				is_on_belt = true
				
	var right_below = $RightRayCast2D.get_collider()
	if right_below != null:
		if right_below.is_in_group("belts"):
			is_on_belt = true
		if right_below.is_in_group("boxes"):
			if right_below.is_on_belt:
				is_on_belt = true
			
	if is_on_belt:
		velocity.x = BELT_SPEED
	else:
		velocity.x = 0

	velocity.y += GRAVITY*delta
	
	velocity = move_and_slide(velocity)
